

#include <stdio.h>
#include <conio.h>
#include <string>
#include <windows.h>

#include "main.h"
#include "io.h"

#include "pci.h"
#include "smbus.h"

#define IDC_MAIN_TEXT   1001

using namespace std;
/* Declare WindowsProcedure */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);
/* Make the classname into a global variable */
char szClassName[] = "Scanner";
HINSTANCE hThisInstance;

static HWND text_hwnd = NULL;


//******************************************************************************************************************************






int pci_scann(HWND hwnd)
{
    
    unsigned int i=0x80000000;
	unsigned int Adresse = 0;
	unsigned int PCI_Data =0;
	unsigned int Device_class =0;
	unsigned int SMBUS_adresse =0;
	unsigned int ii=0;
	char txt_buff[255];
	unsigned int PCI_Register[16];
	struct PCI_config_space conf_space;
	struct PCI_config_space_0 conf_space_0;
	struct PCI_config_space_1 conf_space_1;
	
	
	struct PCI_Class_space class_space;
	
	
	unsigned char iii=0;
	unsigned long d=0;
	unsigned char gefunden=0;
     DWORD len_text=0;
     string  text="";
	
	for(i=PCIBus_adresse;i<PCIBus_Endadr;i=i+PCIBus_Countadr)
	{
		Adresse=i & 0xFFFFFF00;
		PortDWordOut (PORT_Addresse, Adresse);
		PCI_Data = PortDWordIn(PORT_Data);
		if (PCI_Data != PCIBus_Dev_not)
		{   
                iii=4;     
                PCI_Register[0]= PCI_Data;
                for(ii=1;ii<16;ii++)
                {
                      PortDWordOut (PORT_Addresse, Adresse+iii);
		              PCI_Data = PortDWordIn(PORT_Data);
                      PCI_Register[ii]=      PCI_Data;    
                      iii=iii+4;       
                }
                memcpy (&conf_space,&PCI_Register[0],sizeof(PCI_config_space));
                
                
                
                
                len_text=sprintf(txt_buff,"******************************************************************\r\nBus:%2i    Device:%2i    Function:%2i    Register:%2i \r\n",PCI_GetBusnummer(i),PCI_GetDevicenummer(i),PCI_GetFunctionnummer(i),PCI_GetRegisternummer(i));
                txt_buff[len_text+1]=0;
                text +=(string)txt_buff ;
                
                len_text=sprintf(txt_buff,"  Vendor: 0x%X \r\n  Device: 0x%X \r\n",conf_space.VendorID,conf_space.DeviceID);
                txt_buff[len_text+1]=0;
                text +=(string)txt_buff ;
                gefunden=0;
                
                for (d=0;d<PCI_CLASSCODETABLE_LEN;d++)
                {
                    if((PciClassCodeTable[d].BaseClass==conf_space.BaseClass)& (PciClassCodeTable[d].SubClass==conf_space.SubClass)& (PciClassCodeTable[d].ProgIf==conf_space.ProgIf))
                    {
                            //CLass und sub gefunden
                            gefunden=1;
                            len_text=sprintf(txt_buff,"%s \r\n%s \r\n%s \r\n",PciClassCodeTable[d].BaseDesc,PciClassCodeTable[d].SubDesc,PciClassCodeTable[d].ProgDesc);
                            txt_buff[len_text+1]=0;
                            text +=(string)txt_buff ;                                                      
                                                                                  
                    }
                }
                if(gefunden==0)
                {
                    len_text=sprintf(txt_buff,"  Base Class: 0x%X \r\n  Sub Class: 0x%X \r\n  Prog: 0x%X \r\n",conf_space.BaseClass,conf_space.SubClass,conf_space.ProgIf);
                    txt_buff[len_text+1]=0;
                    text +=(string)txt_buff ;
                }
                if((conf_space.HEADERType ==0x1) |(conf_space.HEADERType ==0x81) )//Bridge header
                {
                    memcpy (&conf_space_1,&PCI_Register[0],sizeof(conf_space_1));//PCI_BAR_Speicheradressraum(Data) ((Data>>4) & 0xFFFFFFF)
                    
                    
                        len_text=sprintf(txt_buff,"Base Addresse 0: 0x%lX \r\n",PCI_BAR_Speicheradressraum(conf_space_1.BAR0));
                        txt_buff[len_text+1]=0;
                        text +=(string)txt_buff ;
                    
                        len_text=sprintf(txt_buff,"Base Addresse 1: 0x%lX \r\n",PCI_BAR_Speicheradressraum(conf_space_1.BAR1));
                        txt_buff[len_text+1]=0;
                        text +=(string)txt_buff ;
                }
                                                                      
                                          
                
                else //Normale header
                {
                     memcpy (&conf_space_0,&PCI_Register[0],sizeof(conf_space_0));
                    
                        len_text=sprintf(txt_buff,"Base Addresse 0: 0x%lX \r\n",PCI_BAR_Speicheradressraum(conf_space_0.BAR0));
                        txt_buff[len_text+1]=0;
                        text +=(string)txt_buff ;
                    
                        len_text=sprintf(txt_buff,"Base Addresse 1: 0x%lX \r\n",PCI_BAR_Speicheradressraum(conf_space_0.BAR1));
                        txt_buff[len_text+1]=0;
                        text +=(string)txt_buff ;
                    
                        len_text=sprintf(txt_buff,"Base Addresse 2: 0x%lX \r\n",PCI_BAR_Speicheradressraum(conf_space_0.BAR2));
                        txt_buff[len_text+1]=0;
                        text +=(string)txt_buff ;
                    
                        len_text=sprintf(txt_buff,"Base Addresse 3: 0x%lX \r\n",PCI_BAR_Speicheradressraum(conf_space_0.BAR3));
                        txt_buff[len_text+1]=0;
                        text +=(string)txt_buff ;
                    
                        len_text=sprintf(txt_buff,"Base Addresse 4: 0x%lX \r\n",PCI_BAR_Speicheradressraum(conf_space_0.BAR4));
                        txt_buff[len_text+1]=0;
                        text +=(string)txt_buff ;
                    
                        len_text=sprintf(txt_buff,"Base Addresse 5: 0x%lX \r\n",PCI_BAR_Speicheradressraum(conf_space_0.BAR5));
                        txt_buff[len_text+1]=0;
                        text +=(string)txt_buff ;
                    
                     
                }
                
                           
                
                
                
                
        }
        
    }
    LPCSTR str2 = _strdup(text.c_str());
    SetWindowText(hwnd, str2);
    return 0;
    
    
}





int pci_dump(HWND hwnd)
{
    unsigned int i=0x80000000;
	unsigned int Adresse = 0;
	unsigned int PCI_Data =0;
	unsigned int Device_class =0;
	unsigned int SMBUS_adresse =0;
	unsigned int ii=0;
	char txt_buff[255];
	unsigned int PCI_Register[16];
	unsigned char iii=0;
	unsigned char txtb[4];
	unsigned char iiii=0;
	
	DWORD len_text=0;
    string  text="";
    for(i=PCIBus_adresse;i<PCIBus_Endadr;i=i+PCIBus_Countadr)
	{
            Adresse=i & 0xFFFFFF00;
    		PortDWordOut (PORT_Addresse, Adresse);
    		PCI_Data = PortDWordIn(PORT_Data);
    		if (PCI_Data != PCIBus_Dev_not)
    		{
                    iii=4;     
                    // PCI_Data;
                    
                    len_text=sprintf(txt_buff,"PCI Device \r\n");
                    txt_buff[len_text+1]=0;
                    text +=(string)txt_buff ;
                        
                    memcpy (&txtb[0],&PCI_Data,sizeof(PCI_Data));
                    
                    for (iiii=0;iiii<4;iiii++)
                    {
                         len_text=sprintf(txt_buff,"%2X  ",txtb[iiii]);
                         txt_buff[len_text+1]=0;
                         text +=(string)txt_buff ;
                    }
                    len_text=sprintf(txt_buff,"\r\n");
                    txt_buff[len_text+1]=0;
                    text +=(string)txt_buff ;
                    for(ii=1;ii<16;ii++)
                    {
                          PortDWordOut (PORT_Addresse, Adresse+iii);
    		              PCI_Data = PortDWordIn(PORT_Data);
                          //      PCI_Data;  
                          memcpy (&txtb[0],&PCI_Data,sizeof(PCI_Data)); 
                          for (iiii=0;iiii<4;iiii++)
                          {
                                 len_text=sprintf(txt_buff,"%2X  ",txtb[iiii]);
                                 txt_buff[len_text+1]=0;
                                 text +=(string)txt_buff ;
                          }
                          len_text=sprintf(txt_buff,"\r\n");
                          txt_buff[len_text+1]=0;
                          text +=(string)txt_buff ;
                           
                          iii=iii+4;       
                    }
              len_text=sprintf(txt_buff,"\r\n");
              txt_buff[len_text+1]=0;
              text +=(string)txt_buff ;           
              }
      }
	  LPCSTR str2 = _strdup(text.c_str());
      SetWindowText(hwnd, str2);
      return 0;
}



int smb_scann(HWND hwnd)
{
     unsigned char i=0;
     unsigned char ant=0;
     unsigned char daten=0;
     HANDLE hFile;   
     DWORD len1;
     LPDWORD len2;
     char txt_buff[255];
     DWORD len_text=0;
     string  text="";
     if (Get_SMBus_Adress()==0)
     {
        MessageBox( hwnd, (LPSTR) "SMBus Host addresse nicht gefunden.",
                              (LPSTR) szClassName,
                              MB_ICONINFORMATION | MB_OK );  
        return 1;  
     }
     len_text=sprintf(txt_buff,"SMBus Addresse: 0x%X \r\n",Get_SMBus_Adress());
            txt_buff[len_text+1]=0;
            text +=(string)txt_buff ; 
                
     for (i=0;i<254;i++)
     {
         //char ReadByteSMBus(unsigned int SMBus_port,unsigned char device_nummer,unsigned char cmmd,unsigned char *data);
         ant=ReadByteSMBus(Get_SMBus_Adress(),i,0,&daten);
         if ((ant==0) )
         {
            
            len_text=sprintf(txt_buff,"SMBus gerat gefunden Nummer: %i daten: %X\r\n",i,daten);
            txt_buff[len_text+1]=0;
            text +=(string)txt_buff ;                    
         }
         
             
     }
     LPCSTR str2 = _strdup(text.c_str());
     SetWindowText(hwnd, str2); 
     return 0;
}


int smb_dump(HWND hwnd)
{
     DWORD len_text=0;
     string  text="";
     char txt_buff[255];
     unsigned char adressen[10];
     unsigned char adressen_c=0;
     unsigned char daten=0;
     char zeile_count=0;
     unsigned char i;
     unsigned char ii;
     unsigned char ant=0;
     
     if (Get_SMBus_Adress()==0)
    {
        MessageBox( hwnd, (LPSTR) "SMBus Host addresse nicht gefunden.",
                              (LPSTR) szClassName,
                              MB_ICONINFORMATION | MB_OK );  
        return 1;      
          
    }
     for (i=0;i<254;i++)
     {
         ant=ReadByteSMBus(Get_SMBus_Adress(),i,0,&daten);
         if (ant==0)
         {
              
              adressen[adressen_c]=i;
              adressen_c++;
                               
         }
     }
     for (i=0;i<adressen_c;i++)
     {
         len_text=sprintf(txt_buff,"Device adresse: 0x%X \r\n",adressen[i]);
         txt_buff[len_text+1]=0;
         text +=(string)txt_buff ;
         zeile_count=0;   
         for(ii=0;ii<255;ii++)
         {
                   ant=ReadByteSMBus(Get_SMBus_Adress(),adressen[i],ii,&daten);
                   if(ant!=0)
                       break;      
                       
                   
                  len_text=sprintf(txt_buff,"%2X  ",daten);
                         txt_buff[len_text+1]=0;
                         text +=(string)txt_buff ;
                                           
                   zeile_count++;
                   if(zeile_count>15)
                   {
                          zeile_count=0;
                          len_text=sprintf(txt_buff,"\r\n");
                          txt_buff[len_text+1]=0;
                          text +=(string)txt_buff ;
                                                   
                   }
     
         }
                    
         len_text=sprintf(txt_buff,"\r\n\r\n");
         txt_buff[len_text+1]=0;
         text +=(string)txt_buff ; 
     }
     LPCSTR str2 = _strdup(text.c_str());
     SetWindowText(hwnd, str2); 
}














int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil)

{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application is saved */
    WNDCLASSEX wincl;        /* Datastructure for the windowclass */
    HMENU menu;              /* Handle of the menu */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Ctach double-clicks */
    wincl.cbSize = sizeof(WNDCLASSEX);

    /* Use default icon and mousepointer */
    wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL; /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use lightgray as the background of the window */
    wincl.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);

    /* Register the window class, if fail quit the program */
    if(!RegisterClassEx(&wincl)) return 0;

    /* The class is registered, lets create the program*/
    hwnd = CreateWindowEx(
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "Scanner",         /* Title Text */
           WS_OVERLAPPEDWINDOW, /* defaultwindow */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window end up on the screen */
           544,                 /* The programs width */
           375,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a childwindow to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    LoadIODLL();
    ShowWindow(hwnd, nFunsterStil);

    menu = LoadMenu(hThisInstance, MAKEINTRESOURCE(ID_MENU));
    SetMenu(hwnd, menu);
    
    
    /* Run the nessageloop. It will run until GetMessage( ) returns 0 */
    while(GetMessage(&messages, NULL, 0, 0))
    {
           /* Send message to WindowProcedure */
           DispatchMessage(&messages);
    }

    /* The program returvalue is 0 - The value that PostQuitMessage( ) gave */
    return messages.wParam;
}

/* This function is called by the Windowsfunction DispatchMessage( ) */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                  /* handle the messages */
    {
       case WM_COMMAND:
           switch( wParam )
           {
             case IDM_FILENEW:
             case IDM_FILEOPEN:
             case IDM_FILESAVE:
             case IDM_FILESAVEAS:
             case IDM_FILEPRINT:
             case IDM_FILEPAGESETUP:
             case IDM_FILEPRINTSETUP:

             case IDM_EDITUNDO:
             case IDM_EDITCUT:
             case IDM_EDITCOPY:
             case IDM_EDITPASTE:
             case IDM_EDITDELETE:
                  MessageBox( hwnd, (LPSTR) "Function Not Yet Implemented.",
                              (LPSTR) szClassName,
                              MB_ICONINFORMATION | MB_OK );
                  return 0;

             case IDM_HELPCONTENTS:
                  WinHelp( hwnd, (LPSTR) "HELPFILE.HLP",
                           HELP_CONTENTS, 0L );
                  return 0;

             case IDM_HELPSEARCH:
                  WinHelp( hwnd, (LPSTR) "HELPFILE.HLP",
                           HELP_PARTIALKEY, 0L );
                  return 0;

             case IDM_HELPHELP:
                  WinHelp( hwnd, (LPSTR) "HELPFILE.HLP",
                           HELP_HELPONHELP, 0L );
                  return 0;

             case IDM_FILEEXIT:
                  SendMessage( hwnd, WM_CLOSE, 0, 0L );
                  return 0;

             case IDM_HELPABOUT:
                  MessageBox (NULL, "About..." , "Windows example version 0.01", 1);
                  return 0;
                  
             case IDM_PCISCAN:
                  pci_scann(text_hwnd);
                  return 0;
             case IDM_PCIDUMP:
                  pci_dump(text_hwnd);
                  return 0;
             //MENUITEM "Scan", IDM_PCISCAN
		     //MENUITEM "Dump", IDM_PCIDUMP
		     case IDM_SMSCAN:
                  //pci_scann(text_hwnd);
                  smb_scann(text_hwnd);
                  return 0;
             case IDM_SMDUMP:
                  smb_dump(text_hwnd);
                  return 0;
             //IDM_SMSCAN
             //IDM_SMDUMP
           }
           break;
          case WM_CREATE:
               text_hwnd=CreateWindow("EDIT", "",
               WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL | ES_MULTILINE |
               ES_WANTRETURN,
               CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
               hwnd, (HMENU)IDC_MAIN_TEXT, hThisInstance, NULL);
               SendDlgItemMessage(hwnd, IDC_MAIN_TEXT, WM_SETFONT,
                     (WPARAM)GetStockObject(ANSI_FIXED_FONT), MAKELPARAM(TRUE, 0));
               SetWindowText(text_hwnd, "hallo");
               break;
          case WM_SIZE:
                if(wParam != SIZE_MINIMIZED)
                   MoveWindow(GetDlgItem(hwnd, IDC_MAIN_TEXT), 0, 0, LOWORD(lParam),
                       HIWORD(lParam), TRUE);
                break;
          case WM_SETFOCUS:
                SetFocus(GetDlgItem(hwnd, IDC_MAIN_TEXT));
                break;
          case WM_CLOSE:
               DestroyWindow( hwnd );
               return 0;
    
          case WM_DESTROY:
               PostQuitMessage (0);
               return 0;

      break;
      default:                   /* for messages that we don't deal with */
      return DefWindowProc(hwnd, message, wParam, lParam);
   }
  return 0;
}
