#ifndef _SMBUS_H_
#define _SMBUS_H_


#include "io.h"


#define VDID_PIIX4		0x71138086   //82371AB/EB/MB PIIX4/E/M Power Management Controller.
#define VDID_VIA596A	0x30501106 // VT82C596/A/B Power Management Controller
#define VDID_VIA686A	0x30571106 // VT82C686/A/B Power Management Controller
 
#define VDID_AMD756PM	0x740B1022 // AMD-756 Power Management Controller
#define VDID_AMD766PM	0x74131022 // AMD-766 Power Management Controller
#define VDID_AMD768PM	0x74431022 // AMD-768 ACPI Controller
#define VDID_AMD8111PM  0x746B1022 // AMD-8111 ACPI System Management Controller


#define ATI_SMBus       0x43851002 // Advanced Micro Devices, Inc.","ATI RD600/RS600","ATI SMBus"


#define Adress_port			0xCF8
#define Data_port			0xCFC
#define No_device			0xFFFFFFFF
#define PCI_adresse			0x80000000
#define PCI_Count_ad		0x100
#define PCI_End_adresse		0x80FFFF00

#define  NEWIODELAY()       PortOut(0x0EB, 0xFF)

char wait_busy(unsigned int SMBus_port,unsigned long timm);
unsigned char sm_get_statusregister(unsigned int SMBus_port);


unsigned int Get_SMBus_Adress(void);

unsigned char ReadByteSMBus(unsigned int SMBus_port,unsigned char device_nummer,unsigned char cmmd,unsigned char *data);
unsigned char ReadshortSMBus(unsigned int SMBus_port,unsigned char device_nummer,unsigned char cmmd,unsigned short *data);





#endif //_SMBUS_H_
